/*------------------------------------------------------------------------------
* gencode.c: mex fucntion generate code
*
* 2010/10/15 0.1 new
*-----------------------------------------------------------------------------*/
#include <stdlib.h>
#include "mex.h"

extern void gencode(int sat, double coff, double cs, int ns, short *code);

/* mex interface -------------------------------------------------------------*/
extern void mexFunction(int nargout, mxArray *argout[], int nargin,
                        const mxArray *argin[])
{
    double coff,cs,*code;
    short *codec;
    int i,sat,ns;
    
    if (nargin<4||mxGetM(argin[0])<1||mxGetM(argin[1])<1||mxGetM(argin[2])<1||
        mxGetM(argin[3])<1) {
        mexErrMsgTxt("argin error");
    }
    sat =(int)*mxGetPr(argin[0]); /* I: satellite number */
    coff=     *mxGetPr(argin[1]); /* I: code offset (chip) */
    cs  =     *mxGetPr(argin[2]); /* I: sampling interval (chip) */
    ns  =(int)*mxGetPr(argin[3]); /* I: number of samples */
    
    argout[0]=mxCreateDoubleMatrix(1,ns,mxREAL);
   
    code=     mxGetPr(argout[0]); /* O: code sequence */
    
    if (!(codec=(short *)malloc(sizeof(short)*ns))) {
        mexErrMsgTxt("malloc error");
    }
    /* gererate code */
    gencode(sat,coff,cs,ns,codec);
    
    for (i=0;i<ns;i++) {
        code[i]=(double)codec[i];
    }
    free(codec);
}
